typedef enum _item_classes {
  ATOMIC_ITEM,
  COMPOSITE_ITEM
} item_classes;

struct _atomic {
  item_types type;
  datap data;
} atomic;

struct _composite {
  struct _item *children;
};

struct _callback_rec {
  struct _callback_rec *next, *prev;
  wtid wt;
  datap data;
  int ndata;
  struct _item *parent;
  callback *cb;
};

struct _item {
  item_names name;
  struct _item *next, *prev;
  struct _item *parent;
  item_classes class;
  struct _callback_rec *callbacks;
  union {
    struct _atomic a;
    struct _composite c;
  } contents;
};

struct _bboard {
  wtid cur_wtid;
  struct _item *contents;
};
